/******************************************************************************
 *            echecs_coups_cloues.c                                           *
 *                                                                            *
 *  Copyright  2006  gerald.dumas                                             *
 *  linechec@laposte.net                                                      *
 ******************************************************************************
 *                                                                            *
 *  This program is free software; you can redistribute it and/or modify      *
 *  it under the terms of the GNU General Public License as published by      *
 *  the Free Software Foundation; either version 2 of the License, or         *
 *  any later version.                                                        *
 *                                                                            *
 *  This program is distributed in the hope that it will be useful,           *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU General Public License for more details.                              *
 *                                                                            *
 *  You should have received a copy of the GNU General Public License         *
 *  along with this program; if not, write to the Free Software               *
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.*
 ******************************************************************************/

/* fonction permettant de déterminer si un coup d'une pièce est cloué */

#include "echecs_coups_cloues.h"

GList *
elimination_des_coups_cloues (GList * liste_coups_jouables, int couleur)
{
  type_piece piece_originale;
  struct struct_echiquier case_originale_depart;
  struct struct_echiquier case_originale_arrivee;
  gint nbre_coups_jouables = 0;
  gint pos_piece_tab, coup = 0;
  GList *liste;
  GList *liste_temp = NULL;
  register gint x, y;

  liste = g_list_first (liste_coups_jouables);
  y = g_list_length (liste);
  if (y > 0)
    {
      for (x = 0; x < y; x++)
	{
	  if ((((struct struct_coups_jouables *) (liste->data))->couleur == couleur
			&&((struct struct_coups_jouables *) (liste->data))->coup_ami == FALSE)
			&& ((couleur == blanche
				&& ((struct struct_coups_jouables *) (liste->data))->pos_piece_tab != 16) // Evite le test des coups des rois
		 		|| (couleur == noire
				&& ((struct struct_coups_jouables *) (liste->data))->pos_piece_tab != 32)))	// Evite le test des coups des rois
	    {
	      // Sauvegarde des données
	      pos_piece_tab =
		((struct struct_coups_jouables *) (liste->data))->
		pos_piece_tab;
	      coup = ((struct struct_coups_jouables *) (liste->data))->coup;
	      case_originale_depart =
		echiquier[table_piece[pos_piece_tab].place];
	      case_originale_arrivee = echiquier[coup];
	      piece_originale = table_piece[pos_piece_tab];
	      nbre_coups_jouables =
		table_piece[pos_piece_tab].nbre_cases_jouables;

	      // effacement de la piece sur l'échiquier
	      echiquier[table_piece[pos_piece_tab].place].type_piece = vide;

	      // Initialisation de la nouvelle position dans table_piece
	      table_piece[pos_piece_tab].place = coup;

	      // positionnement de la pièce sur l'échiquier
	      echiquier[table_piece[pos_piece_tab].place].type_piece =
		table_piece[pos_piece_tab].type;
	      echiquier[table_piece[pos_piece_tab].place].couleur_piece =
		table_piece[pos_piece_tab].couleur;
	      echiquier[table_piece[pos_piece_tab].place].pos_table_piece =
		pos_piece_tab;

	      if (le_roi_est_en_echec (couleur) == TRUE)
		{
		  // suppression du coup jouable actuellement pointé
		  liste_coups_jouables = liste;
		  liste_temp = g_list_next (liste);
		  g_free (((struct struct_coups_jouables
			    *) (liste_coups_jouables->data)));
		  liste_coups_jouables =
		    g_list_remove (liste_coups_jouables,
				   ((struct struct_coups_jouables
				     *) (liste_coups_jouables->data)));
		  liste = liste_temp;

		  // Décrémentation du nbre de coup jouable de la pièce
		  nbre_coups_jouables--;
		}
	      else
		{
		  liste = g_list_next (liste);
		}

	      // restauration des données originales avec MAJ du nbre de coups jouables
	      table_piece[pos_piece_tab] = piece_originale;
	      echiquier[table_piece[pos_piece_tab].place] =
		case_originale_depart;
	      echiquier[coup] = case_originale_arrivee;
	      table_piece[pos_piece_tab].nbre_cases_jouables =
		nbre_coups_jouables;
	    }
	  else
	    {
	      liste = g_list_next (liste);
	    }
	}
    }

  return g_list_first (liste_coups_jouables);
}
