/******************************************************************************
 *            g_affichage_echiquier.c                                         *
 *                                                                            *
 *  Copyright  2006  gerald.dumas                                             *
 *  linechec@laposte.net                                                      *
 ******************************************************************************
 *                                                                            *
 *  This program is free software; you can redistribute it and/or modify      *
 *  it under the terms of the GNU General Public License as published by      *
 *  the Free Software Foundation; either version 2 of the License, or         *
 *  any later version.                                                        *
 *                                                                            *
 *  This program is distributed in the hope that it will be useful,           *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU General Public License for more details.                              *
 *                                                                            *
 *  You should have received a copy of the GNU General Public License         *
 *  along with this program; if not, write to the Free Software               *
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.*
 ******************************************************************************/

#include "g_affichage_echiquier.h"

struct g_position position_souris (gdouble x, gdouble y)
{
  struct g_position coord;
  coord.x = 0;
  coord.y = 0;

  if (((x >= 20) && (x <= TAILLE_PIECE)) && ((y >= 20) && (y <= (gint)((TAILLE_PIECE*8)+20))))
    {
      if (!g_echiquier_inverse)
	coord.x = 1;
      else
	coord.x = 8;
    }
  if (((x >= 20+TAILLE_PIECE) && (x <= 20+(TAILLE_PIECE*2))) && ((y >= 20) && (y <= (gint)((TAILLE_PIECE*8)+20))))
    {
      if (!g_echiquier_inverse)
	coord.x = 2;
      else
	coord.x = 7;
    }
  if (((x >= 20+(TAILLE_PIECE*2)) && (x <= 20+(TAILLE_PIECE*3))) && ((y >= 20) && (y <= (gint)((TAILLE_PIECE*8)+20))))
    {
      if (!g_echiquier_inverse)
	coord.x = 3;
      else
	coord.x = 6;
    }
  if (((x >= 20+(TAILLE_PIECE*3)) && (x <= 20+(TAILLE_PIECE*4))) && ((y >= 20) && (y <= (gint)((TAILLE_PIECE*8)+20))))
    {
      if (!g_echiquier_inverse)
	coord.x = 4;
      else
	coord.x = 5;
    }
  if (((x >= 20+(TAILLE_PIECE*4)) && (x <= 20+(TAILLE_PIECE*5))) && ((y >= 20) && (y <= (gint)((TAILLE_PIECE*8)+20))))
    {
      if (!g_echiquier_inverse)
	coord.x = 5;
      else
	coord.x = 4;
    }
  if (((x >= 20+(TAILLE_PIECE*5)) && (x <= 20+(TAILLE_PIECE*6))) && ((y >= 20) && (y <= (gint)((TAILLE_PIECE*8)+20))))
    {
      if (!g_echiquier_inverse)
	coord.x = 6;
      else
	coord.x = 3;
    }
  if (((x >= 20+(TAILLE_PIECE*6)) && (x <= 20+(TAILLE_PIECE*7))) && ((y >= 20) && (y <= (gint)((TAILLE_PIECE*8)+20))))
    {
      if (!g_echiquier_inverse)
	coord.x = 7;
      else
	coord.x = 2;
    }
  if (((x >= 20+(TAILLE_PIECE*7)) && (x <= 20+(TAILLE_PIECE*8))) && ((y >= 20) && (y <= (gint)((TAILLE_PIECE*8)+20))))
    {
      if (!g_echiquier_inverse)
	coord.x = 8;
      else
	coord.x = 1;
    }


  if (((y >= 20) && (y <= 20+(TAILLE_PIECE*1))) && ((x >= 20) && (x <= (gint)((TAILLE_PIECE*8)+20))))
    {
      if (!g_echiquier_inverse)
	coord.y = 8;
      else
	coord.y = 1;
    }
  if (((y >= 20+(TAILLE_PIECE*1)) && (y <= 20+(TAILLE_PIECE*2))) && ((x >= 20) && (x <= (gint)((TAILLE_PIECE*8)+20))))
    {
      if (!g_echiquier_inverse)
	coord.y = 7;
      else
	coord.y = 2;
    }
  if (((y >= 20+(TAILLE_PIECE*2)) && (y <= 20+(TAILLE_PIECE*3))) && ((x >= 20) && (x <= (gint)((TAILLE_PIECE*8)+20))))
    {
      if (!g_echiquier_inverse)
	coord.y = 6;
      else
	coord.y = 3;
    }
  if (((y >= 20+(TAILLE_PIECE*3)) && (y <= 20+(TAILLE_PIECE*4))) && ((x >= 20) && (x <= (gint)((TAILLE_PIECE*8)+20))))
    {
      if (!g_echiquier_inverse)
	coord.y = 5;
      else
	coord.y = 4;
    }
  if (((y >= 20+(TAILLE_PIECE*4)) && (y <= 20+(TAILLE_PIECE*5))) && ((x >= 20) && (x <= (gint)((TAILLE_PIECE*8)+20))))
    {
      if (!g_echiquier_inverse)
	coord.y = 4;
      else
	coord.y = 5;
    }
  if (((y >= 20+(TAILLE_PIECE*5)) && (y <= 20+(TAILLE_PIECE*6))) && ((x >= 20) && (x <= (gint)((TAILLE_PIECE*8)+20))))
    {
      if (!g_echiquier_inverse)
	coord.y = 3;
      else
	coord.y = 6;
    }
  if (((y >= 20+(TAILLE_PIECE*6)) && (y <= 20+(TAILLE_PIECE*7))) && ((x >= 20) && (x <= (gint)((TAILLE_PIECE*8)+20))))
    {
      if (!g_echiquier_inverse)
	coord.y = 2;
      else
	coord.y = 7;
    }
  if (((y >= 20+(TAILLE_PIECE*7)) && (y <= 20+(TAILLE_PIECE*8))) && ((x >= 20) && (x <= (gint)((TAILLE_PIECE*8)+20))))
    {
      if (!g_echiquier_inverse)
	coord.y = 1;
      else
	coord.y = 8;
    }
  return coord;
}

gboolean souris_dans_case (int place)
{
  if ((((echiquier[place].x == 1) || (echiquier[place].x == 3)
	|| (echiquier[place].x == 5) || (echiquier[place].x == 7))
       && ((echiquier[place].y == 1) || (echiquier[place].y == 3)
	   || (echiquier[place].y == 5) || (echiquier[place].y == 7)))
      ||
      (((echiquier[place].x == 2) || (echiquier[place].x == 4)
	|| (echiquier[place].x == 6) || (echiquier[place].x == 8))
       && ((echiquier[place].y == 2) || (echiquier[place].y == 4)
	   || (echiquier[place].y == 6) || (echiquier[place].y == 8))))
    return TRUE;
  else
    return FALSE;
}

void affichage_joueur ()
{
  GdkColor couleur_case_rouge;
  GdkColormap *colormap;
  PangoLayout *layout;
	GtkWidget *Zone_dessin;
	Zone_dessin=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "Zone dessin"));

  couleur_case_rouge.red = 65000;
  couleur_case_rouge.green = 0;
  couleur_case_rouge.blue = 0;

  colormap = gdk_drawable_get_colormap (Zone_dessin->window);
  gdk_colormap_alloc_color (colormap, &couleur_case_rouge, FALSE, FALSE);
  gdk_gc_set_foreground (Zone_dessin->style->
			 fg_gc[GTK_WIDGET_STATE (Zone_dessin)],
			 &couleur_case_rouge);

  // Affichage du texte "Aux noirs/blancs à jouer ..."
  if (humain_joue == blanc)
    {
      gdk_window_clear_area (Zone_dessin->window, 0, 0, 200, 20);
      layout = pango_layout_new (gtk_widget_get_pango_context (Zone_dessin));
      pango_layout_set_text (layout, "Aux blancs de jouer...", 22);
      gdk_draw_layout (Zone_dessin->window,
		       Zone_dessin->style->
		       fg_gc[GTK_WIDGET_STATE (Zone_dessin)], 20, 0, layout);
    }
  else
    {
      gdk_window_clear_area (Zone_dessin->window, 0, 0, 200, 20);
      layout = pango_layout_new (gtk_widget_get_pango_context (Zone_dessin));
      pango_layout_set_text (layout, "Aux noirs de jouer...", 21);
      gdk_draw_layout (Zone_dessin->window,
		       Zone_dessin->style->
		       fg_gc[GTK_WIDGET_STATE (Zone_dessin)], 20, 0, layout);
    }

  couleur_case_rouge.red = 0;
  couleur_case_rouge.green = 0;
  couleur_case_rouge.blue = 0;

  gdk_colormap_alloc_color (colormap, &couleur_case_rouge, FALSE, FALSE);
  gdk_gc_set_foreground (Zone_dessin->style->
			 fg_gc[GTK_WIDGET_STATE (Zone_dessin)],
			 &couleur_case_rouge);
}

void affichage_piece (gint piece, gint couleur_piece, gint position)
{
	GtkWidget *Zone_dessin;
	Zone_dessin=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "Zone dessin"));

  if (g_echiquier_inverse)
    gdk_draw_pixbuf (Zone_dessin->window,
		     Zone_dessin->style->
		     fg_gc[GTK_WIDGET_STATE (Zone_dessin)],
		     buf_images[piece][couleur_piece], 0, 0,
		     20 + ((TAILLE_PIECE * 7) -
			   (echiquier[position].x - 1) * TAILLE_PIECE),
		     20 + ((echiquier[position].y - 1) * TAILLE_PIECE),
		     TAILLE_PIECE, TAILLE_PIECE,
		     GDK_RGB_DITHER_NORMAL, 0, 0);
  else
    gdk_draw_pixbuf (Zone_dessin->window,
		     Zone_dessin->style->fg_gc[GTK_WIDGET_STATE (Zone_dessin)],
		     buf_images[piece][couleur_piece], 0, 0,
		     20 + ((echiquier[position].x - 1) * TAILLE_PIECE),
		     20 + ((TAILLE_PIECE * 7) - (echiquier[position].y - 1) * TAILLE_PIECE),
		     TAILLE_PIECE, TAILLE_PIECE,
		     GDK_RGB_DITHER_NORMAL, 0, 0);
}

void affichage_coordonnees ()
{
  PangoLayout *layout;
	gchar abscisse[8]={'A','B','C','D','E','F','G','H'};	// Abscisse
	gchar ordonnee[8]={'1','2','3','4','5','6','7','8'};	// Ordonnée
	gint lettre;
	gint chiffre;
	GtkWidget *Zone_dessin;
	Zone_dessin=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "Zone dessin"));

  layout = pango_layout_new (gtk_widget_get_pango_context (Zone_dessin));

  if (!g_echiquier_inverse)
    {
      // Insertion des nouvelles coordonnées
			for (lettre=0; lettre<8; lettre++)
			{
	      pango_layout_set_text (layout, &abscisse[lettre], 1);
	      gdk_draw_layout (Zone_dessin->window,
		       Zone_dessin->style->
		       fg_gc[GTK_WIDGET_STATE (Zone_dessin)], 25+(gint)((TAILLE_PIECE-20)/2)+(TAILLE_PIECE*lettre), (gint)((TAILLE_PIECE*8)+20),
		       layout);
			}

			for (chiffre=7; chiffre>-1; chiffre--)
			{
	      pango_layout_set_text (layout, &ordonnee[chiffre], 1);
	      gdk_draw_layout (Zone_dessin->window,
		       Zone_dessin->style->
		       fg_gc[GTK_WIDGET_STATE (Zone_dessin)], 10, 25+(gint)((TAILLE_PIECE-20)/2)+(TAILLE_PIECE*(7-chiffre)), layout);
			}
    }
  else
    {
			// Insertion des nouvelles coordonnées
			for (lettre=0; lettre<8; lettre++)
			{
	      pango_layout_set_text (layout, &abscisse[lettre], 1);
	      gdk_draw_layout (Zone_dessin->window,
		       Zone_dessin->style->
		       fg_gc[GTK_WIDGET_STATE (Zone_dessin)], 25+(gint)((TAILLE_PIECE-20)/2)+(TAILLE_PIECE*(7-lettre)), (gint)((TAILLE_PIECE*8)+20),
		       layout);
			}

			for (chiffre=7; chiffre>-1; chiffre--)
			{
	      pango_layout_set_text (layout, &ordonnee[chiffre], 1);
	      gdk_draw_layout (Zone_dessin->window,
		       Zone_dessin->style->
		       fg_gc[GTK_WIDGET_STATE (Zone_dessin)], 10, 25+(gint)((TAILLE_PIECE-20)/2)+(TAILLE_PIECE*chiffre), layout);
			}
    }
}

gboolean case_cliquee (GtkWidget * widget, GdkEventButton * ev, gpointer * ptr)
{
	GtkWidget *Zone_dessin;
	Zone_dessin=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "Zone dessin"));
	GtkWidget *menu_gnuchess_show_play;
	menu_gnuchess_show_play=(GtkWidget*)
						(gtk_data_list_get_by_name(widget_list, "menu gnuchess show play"));

  // On redessine l'échiquier pour effacer éventuellement le trait montrant le coup adverse de gnuchess
  if (gnuchess)
	{
		if (gtk_check_menu_item_get_active
			(GTK_CHECK_MENU_ITEM (menu_gnuchess_show_play)))
			gtk_widget_queue_draw (Zone_dessin);
	}

  //Sauvegarde en globale de la position de la souris au moment du clique sur l'échiquier.
  souris = position_souris (ev->x, ev->y);

  //Exécution des différentes fonctions lors du clique de la souris sur l'échiquier.
  g_afficher_coups_jouables (g_case_selectionnee);
  g_piece_selectionnee ();
  g_jouer_coup ();

  return TRUE;
}

void g_drag_begin (GtkWidget * widget, GdkDragContext * drag_context,
	      																										gpointer user_data)
{
  gint8 coordonnee_echiquier;
  GdkPixbuf *src;
  gchar *chemin = NULL;
  gchar *tmp, *tmp2;
	GtkWidget *Zone_dessin;
	Zone_dessin=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "Zone dessin"));

	// conversion des coordonnées x y en coordonnées tableau
  coordonnee_echiquier = 110 + ((souris.x - 1) - (12 * (souris.y - 1)));

  // Affectation de l'image de la pièce à la souris pour le DND avec effacement
	// de la piece prise ou un interdit dans les autres cas.
  if (echiquier[coordonnee_echiquier].type_piece != vide
      && echiquier[coordonnee_echiquier].couleur_piece == humain_joue)
	{
		if (strstr (g_get_current_dir (), "/usr/bin"))
			// DEBUG by xcfaudio: changing the order of directories
			// tmp=g_strdup("/usr/share/linechec/pixmaps");
			tmp=g_strdup("/usr/share/pixmaps/linechec");
		else
			tmp=g_strdup_printf("%s/pixmaps",g_key_file_get_string(key_file_config,
																								"DIRECTORY", "install", NULL));
		tmp2 = g_key_file_get_string (key_file_config, "DIRECTORY", "chess_pixmaps",
																		NULL);
		chemin = g_strdup_printf ("%s/echiquier/%s/%s", tmp, tmp2,
							table_nom_images[echiquier[coordonnee_echiquier].type_piece]
							[echiquier[coordonnee_echiquier].couleur_piece]);
		src = gdk_pixbuf_new_from_file_at_scale(chemin, TAILLE_PIECE, TAILLE_PIECE, FALSE, NULL);
		g_free (chemin);
		
		// DEBUG by xcfaudio: Test if the pointer is valid
		if( NULL != src ) {
			gtk_drag_source_set_icon_pixbuf (Zone_dessin, src);
			g_object_unref (src);
		}
		g_free (tmp);
		g_free (tmp2);
	}
  else				// Case vide.
    gtk_drag_source_set_icon_stock (Zone_dessin, GTK_STOCK_CANCEL);
}

void g_traitement_dnd_echiquier (GtkWidget * widget, GdkDragContext * dc,
																				gint x, gint y, guint t, gpointer data)
{
  // Traduction des coordonnées écran du lâché de la pièce en coordonnées échiquier.
  souris = position_souris (x, y);

  //Exécution des différentes fonctions lors du relaché de la souris sur l'échiquier.
  g_afficher_coups_jouables (g_case_selectionnee);
  g_piece_selectionnee ();
  g_jouer_coup ();
}

gboolean affichage_echiquier (GtkWidget * widget, GdkEventExpose * event,
		     																										gpointer user_data)
{
  register int x, y;
  GdkColormap *colormap;	//colormap de l'échiquier
  GdkColor couleur_texte;
	GtkWidget *Zone_dessin;
	Zone_dessin=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "Zone dessin"));

  colormap = gdk_drawable_get_colormap (Zone_dessin->window);

  couleur_texte.red = 0;
  couleur_texte.green = 0;
  couleur_texte.blue = 0;

  gdk_colormap_alloc_color (colormap, &couleur_texte, FALSE, FALSE);
  gdk_gc_set_foreground (Zone_dessin->style->
			 fg_gc[GTK_WIDGET_STATE (Zone_dessin)],
			 &couleur_texte);

  //écriture des coordonnées
  gdk_window_clear_area (Zone_dessin->window, 0, 0, 20,
			 (TAILLE_PIECE * 8) + 40);
  gdk_window_clear_area (Zone_dessin->window, 0,
			 (TAILLE_PIECE * 8) + 20,
			 (TAILLE_PIECE * 8) + 40, 20);
  affichage_coordonnees ();

  // Affichage de l'échiquier
  y = 0;
  do
    {
      x = 0;
      do
	{
	  affichage_piece (vide, blanche, (y + 26) + x);	// cases blanches
	  affichage_piece (vide, noire, (y + 27) + x);	// cases noires
	  affichage_piece (vide, blanche, (y + 39) + x);	// cases blanches
	  affichage_piece (vide, noire, (y + 38) + x);	// cases noires
	  x = x + 2;
	}
      while (x < 8);
      y = y + 24;
    }
  while (y < 96);

  // mise en place graphique des pieces en fonction du tableau table_piece
	// ainsi que des cases vides.
  for (x = 26; x < 118; x++)
    {
      // affichage de la piece considérée ou d'une case vide
      if (echiquier[x].type_piece != bord && echiquier[x].type_piece != vide)
	affichage_piece (echiquier[x].type_piece, echiquier[x].couleur_piece,
			 x);
    }

  // Affichage des coups jouables
  g_afficher_coups_jouables (g_case_selectionnee);

  // Indique quelle couleur doit jouer
  affichage_joueur ();

  // Affichage/effacement du carré de sélection
//      g_piece_selectionnee();

  return TRUE;
}

void creation_echiquier_graphic (GtkWidget * fenetre_principale,
																															GtkWidget * paned)
{
  g_echiquier_inverse = FALSE;
  GtkTargetList *liste_cible;
  GtkTargetEntry cible;
	GtkWidget *Zone_dessin;

  Zone_dessin = gtk_drawing_area_new ();
	widget_list=gtk_data_list_add_by_name(widget_list,Zone_dessin, "Zone dessin");
  gtk_widget_set_size_request (Zone_dessin, (TAILLE_PIECE * 8) + 40,
			       (TAILLE_PIECE * 8) + 40);
	gtk_paned_add1(GTK_PANED(paned), Zone_dessin);

  g_signal_connect (G_OBJECT (Zone_dessin), "expose_event",
																				(GCallback) affichage_echiquier, NULL);

  // un bouton de la souris à été pressé ou le pointeur de la souris à bougé
  gtk_widget_add_events (Zone_dessin,
																GDK_BUTTON_PRESS_MASK|GDK_POINTER_MOTION_MASK);

  // Initialisation du DND de l'échiquier
  // Initialisation d'une structure GtkTargetEntry
  cible.target = "echiquier";
  cible.flags = GTK_TARGET_SAME_APP;
  gtk_drag_source_set (Zone_dessin, GDK_BUTTON1_MASK, &cible,1,GDK_ACTION_COPY);
  // Création de la liste des cibles
  liste_cible = gtk_target_list_new (&cible, 1);
  // Initialisation du widget de l'échiquier pour pouvoir recevoir un DND
  gtk_drag_dest_set (Zone_dessin, GTK_DEST_DEFAULT_MOTION, &cible, 1,
		     GDK_ACTION_COPY);
  gtk_drag_dest_set_target_list (Zone_dessin, liste_cible);
  g_signal_connect (G_OBJECT (Zone_dessin), "button_press_event",
		    (GCallback) case_cliquee, NULL);
  // Affectation d'une icône de drag lors du début du drag
  g_signal_connect_after (G_OBJECT (Zone_dessin), "drag_begin",
			  (GCallback) g_drag_begin, &souris);
  // Lors d'un déposé d'une pièce, la fonction g_traitement_dnd() est éxécutée
  g_signal_connect (G_OBJECT (Zone_dessin), "drag_drop",
		    (GCallback) g_traitement_dnd_echiquier, NULL);

  // Affichage des données liées à la case parcourue par la souris.
  if (debug)
    g_signal_connect_after (G_OBJECT (Zone_dessin), "motion_notify_event",
			  																  (GCallback) affich_donnee_case, NULL);
}

void inversion_echiquier ()
{
  if (g_echiquier_inverse)
    g_echiquier_inverse = FALSE;
  else
    g_echiquier_inverse = TRUE;
  affichage_echiquier (NULL, NULL, NULL);
}

gboolean g_piece_selectionnee ()
{
  register int z;
  GdkColor couleur_case_rouge;
  GdkColormap *colormap;
  short int coordonnee_echiquier;
  short int couleur_piece = blanche;
  short int piece;
	GtkWidget *Zone_dessin;
	Zone_dessin=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "Zone dessin"));

  couleur_case_rouge.red = 65000;
  couleur_case_rouge.green = 0;
  couleur_case_rouge.blue = 0;

  colormap = gdk_drawable_get_colormap (Zone_dessin->window);
  gdk_colormap_alloc_color (colormap, &couleur_case_rouge, FALSE, FALSE);
  gdk_gc_set_foreground (Zone_dessin->style->
			fg_gc[GTK_WIDGET_STATE (Zone_dessin)], &couleur_case_rouge);

	// si la souris est bien sur une des cases de l'échiquier et non sur un bord
  if ((souris.x != 0) && (souris.y != 0))
	{
		// conversion des coordonnées x y en coordonnées tableau
		coordonnee_echiquier = 110 + ((souris.x - 1) - (12 * (souris.y - 1)));
		// En 1er effacement du cadre rouge qui entoure la case anciennement
		// sélectionnée.
		if (g_case_selectionnee.type != vide)
		{
			// détermination de la couleur de la pièce
			couleur_piece = g_case_selectionnee.couleur;
			piece = echiquier[g_case_selectionnee.place].type_piece;
	
			// On efface la case complète en dessinant une case vide
			affichage_piece (vide,
					 echiquier[g_case_selectionnee.place].couleur_case,
					 g_case_selectionnee.place);
			// On redessine la pièce
			affichage_piece (piece, couleur_piece, g_case_selectionnee.place);
			g_case_selectionnee.type = vide;	// plus de case sélectionnée
		}
		// Affichage du cadre entourant la pièce
		for (z = 1; z < 33; z++)
		{
	  	if ((table_piece[z].type != vide) &&
	      (table_piece[z].place == coordonnee_echiquier))
	    {
				// interdiction de sélectionner une pièce adverse
	      if (table_piece[z].couleur == humain_joue)
				{
		  		g_case_selectionnee = table_piece[z];
		  		if (!g_echiquier_inverse)
		    		gdk_draw_rectangle (Zone_dessin->window,
							Zone_dessin->style->fg_gc[GTK_WIDGET_STATE (Zone_dessin)],
							FALSE,
							21 + ((echiquier[table_piece[z].place].x - 1) * TAILLE_PIECE),
							21 + ((8 - echiquier[table_piece[z].place].y) * TAILLE_PIECE),
							TAILLE_PIECE-3, TAILLE_PIECE-3);
		 			else
		    		gdk_draw_rectangle (Zone_dessin->window,
							Zone_dessin->style->fg_gc[GTK_WIDGET_STATE (Zone_dessin)],
							FALSE,
							((TAILLE_PIECE*7)+21)- (((echiquier[table_piece[z].place].x -
								 1) * TAILLE_PIECE)),
							((TAILLE_PIECE*7)+21)- ((8 - echiquier[table_piece[z].place].y)
							* TAILLE_PIECE),
							TAILLE_PIECE-3, TAILLE_PIECE-3);
				}
	    }
		}
	}
  couleur_case_rouge.red = 0;
  couleur_case_rouge.green = 0;
  couleur_case_rouge.blue = 0;

  gdk_colormap_alloc_color (colormap, &couleur_case_rouge, FALSE, FALSE);
  gdk_gc_set_foreground (Zone_dessin->style->
			 fg_gc[GTK_WIDGET_STATE (Zone_dessin)], &couleur_case_rouge);
  return TRUE;
}


gboolean affich_donnee_case (GtkWidget *zonedessin, GdkEventMotion * ev,
																														gpointer user_data)
{
	static GtkWidget *windows_tips;
	static GtkWidget *label;
	gchar *valeurcase;
	gchar *valeur_case;
	gchar *typepiece;
	gchar *roiechec;
	gchar *nbre_case_jouable;
	gchar *dep_init;
	gchar *case_attaquee;
	gchar *casevide;
	
	gint coordonnee_echiquier;
	register int z;
	struct g_position coord;
	short int type_piece;

  coord = position_souris (ev->x, ev->y);

	// Création de la nouvelle fenêtre
	if (!windows_tips)
	{
		GtkWidget *fenetre_principale;
		fenetre_principale=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "fenetre_principale"));

		windows_tips=gtk_window_new(GTK_WINDOW_TOPLEVEL);
		gtk_window_set_transient_for(GTK_WINDOW(windows_tips),
																							GTK_WINDOW(fenetre_principale));
		g_signal_connect (G_OBJECT (windows_tips), "delete_event",
																						(GCallback) gtk_widget_hide, NULL);
		g_signal_connect (G_OBJECT (windows_tips), "destroy",
																						(GCallback) gtk_widget_hide, NULL);
	}

  if ((coord.x != 0) && (coord.y != 0))
	{
		// Destruction de l'ancien label de tooltips
		if (label) gtk_widget_destroy(label);

		// conversion des coordonnées x y en coordonnées tableau
		coordonnee_echiquier = 110 + ((coord.x - 1) - (12 * (coord.y - 1)));

		valeurcase = g_strdup_printf("case : %d\nPonderation case : %d\nTotal\
cases jouables blanc: %d\nTotal cases jouables noir: %d\n\n",
							coordonnee_echiquier, echiquier[coordonnee_echiquier].ponderation,
							longueur_par_couleur_dans_liste (liste_coups_jouables, blanc),
							longueur_par_couleur_dans_liste (liste_coups_jouables, noir));

/*		valeurcase=g_strdup_printf("Total cases jouables blanc: %d\n\
Total cases jouables noir: %d\n\n",
	longueur_par_couleur_dans_liste(liste_coups_jouables,blanc),
	longueur_par_couleur_dans_liste(liste_coups_jouables,noir));
*/
		typepiece = "";
		roiechec = "";
		case_attaquee = "";
		if (echiquier[coordonnee_echiquier].type_piece == vide)
			casevide = "case vide\n";
		else
			casevide = "";
		nbre_case_jouable = NULL;
		dep_init = NULL;

		// recherche de la pièce pointée
		for (z = 1; z < 33; z++)
		{
			if (table_piece[z].type != vide)
			{
				if (table_piece[z].place == coordonnee_echiquier)
				{
					// affichage des données des pièces

					type_piece = table_piece[z].type;
					switch (type_piece)
					{
						case pion:
						{
							typepiece = "pion\n";
							break;
						}

						case tour:
						{
							typepiece = "tour\n";
							break;
						}

						case cavalier:
						{
							typepiece = "cavalier\n";
							break;
						}

						case fou:
						{
							typepiece = "fou\n";
							break;
						}

						case dame:
						{
							typepiece = "dame\n";
							break;
						}

						case roi:
						{
							typepiece = "roi\n";
						}
					}
					if (le_roi_est_en_echec (blanc))
						roiechec = "Le roi blanc est en echec.\n";
					else if (le_roi_est_en_echec (noir))
						roiechec = "Le roi noir est en echec.\n";

					nbre_case_jouable = g_strdup_printf ("Elle peut jouer %d cases.\n",
																					table_piece[z].nbre_cases_jouables);

					if (table_piece[z].deplacement_initial)
						dep_init = g_strdup_printf ("Elle n'a pas bougee.\n");
					else
						dep_init = g_strdup_printf ("Elle a deja bougee.\n");
				}
			}
		}
		if (case_attaquee_par_couleur (coordonnee_echiquier, blanche) == TRUE)
			case_attaquee = "Case attaquee par les blancs.\n";
		if (case_attaquee_par_couleur (coordonnee_echiquier, noire) == TRUE)
			case_attaquee = "Case attaquee par les noirs.\n";

		valeur_case = g_strconcat (valeurcase, casevide, typepiece, roiechec,
														nbre_case_jouable, case_attaquee, dep_init, NULL);
		g_free (valeurcase);

		// Création d'une fenêtre popup pour affichage du debug façon tooltips
		label=gtk_label_new(valeur_case);
		gtk_container_add(GTK_CONTAINER(windows_tips), label);

		g_free (valeur_case);
		g_free (nbre_case_jouable);
		g_free (dep_init);
		gtk_widget_show_all(windows_tips);
	}
	else
		gtk_widget_hide(windows_tips);
  return TRUE;
}

gboolean g_jouer_coup ()
{
  GdkColor couleur_case_rouge;
  GdkColormap *colormap;
  gint coordonnee_echiquier = 0;
  gchar piece;
  gint couleur_piece;
  gint type_deplacement = 0;
	GtkWidget *Zone_dessin;
	Zone_dessin=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "Zone dessin"));
	GtkWidget *bouton_debut;
	bouton_debut=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "bouton debut"));
	GtkWidget *bouton_recul;
	bouton_recul=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "bouton recul"));
	GtkWidget *menu_enregistrer;
	menu_enregistrer=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "menu enregistrer"));
	GtkWidget *menu_jouer_gnuchess;
	menu_jouer_gnuchess=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "menu jouer gnuchess"));
	GtkWidget *barre_outils;
	barre_outils=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "barre outils"));
	GIOChannel *channel_write;
	channel_write=(GIOChannel*)
								(gtk_data_list_get_by_name(widget_list, "channel write"));

  couleur_case_rouge.red = 65000;
  couleur_case_rouge.green = 0;
  couleur_case_rouge.blue = 0;

  colormap = gdk_drawable_get_colormap (Zone_dessin->window);
  gdk_colormap_alloc_color (colormap, &couleur_case_rouge, FALSE, FALSE);
  gdk_gc_set_foreground (Zone_dessin->style->
			 fg_gc[GTK_WIDGET_STATE (Zone_dessin)],
			 &couleur_case_rouge);

	// si la souris est bien sur une des cases de l'échiquier
  if ((souris.x != 0) && (souris.y != -0))
	{
		// conversion des coordonnées x y en coordonnées tableau
		coordonnee_echiquier = 110 + ((souris.x - 1) - (12 * (souris.y - 1)));

		if (g_case_pour_etre_jouee.type != vide)	// si une piece est déja sélectionnée alors ...
		{
			// détemination de la couleur de la pièce
			couleur_piece = g_case_pour_etre_jouee.couleur;
			piece = g_case_pour_etre_jouee.type;
	
			// Si la case choisie correspond à un coup jouable de la pièce
			// sélectionnée alors ...
			if (recherche_coup_dans_liste
					(liste_coups_jouables, couleur_piece,
					 g_case_pour_etre_jouee.place, coordonnee_echiquier) == TRUE)
	    {
	      // Effacement de la pièce graphique
	      affichage_piece (vide,
			       echiquier[g_case_pour_etre_jouee.place].
			       couleur_case, g_case_pour_etre_jouee.place);

	      // Si c'est une prise (autre qu'en passant) il faut effacer la pièce
				// prise.
	      if (echiquier[coordonnee_echiquier].type_piece != vide)
					affichage_piece (vide, echiquier[coordonnee_echiquier].couleur_case,
					coordonnee_echiquier);

	      // MAJ des différentes pièces mises en jeu dans ce déplacement
	      // dans les différents tableaux concernés
	      type_deplacement = deplacer_piece (liste_coups_jouables,
																	g_case_pour_etre_jouee, coordonnee_echiquier);

	      // Vidange de la liste des coups jouables
	      vider_liste (liste_coups_jouables);
	      liste_coups_jouables = NULL;

	      // calcul des nouveaux coups jouables pour chaque pièce
	      liste_coups_jouables = calcul_cases_jouables (liste_coups_jouables);

	      // Suppression des coups non jouables suite à clouage.
	      if (!gnuchess)
				{
					if (humain_joue == blanc)
						liste_coups_jouables =
							elimination_des_coups_cloues (liste_coups_jouables, noir);
					else
						liste_coups_jouables =
							elimination_des_coups_cloues (liste_coups_jouables, blanc);
				}
				else
				{
					if (couleur_humain == blanc)
						liste_coups_jouables =
							elimination_des_coups_cloues (liste_coups_jouables, noir);
					else
						liste_coups_jouables =
							elimination_des_coups_cloues (liste_coups_jouables, blanc);
				}

	      // MAJ de l'état du bouton d'annulation, du bouton sauver et menu d'enregistrement
	      gtk_widget_set_sensitive (GTK_WIDGET(gtk_toolbar_get_nth_item
																			(GTK_TOOLBAR (barre_outils), 6)), TRUE);
	      gtk_widget_set_sensitive (menu_enregistrer, TRUE);
				gtk_widget_set_sensitive (GTK_WIDGET(gtk_toolbar_get_nth_item
																		(GTK_TOOLBAR (barre_outils), 3)), TRUE);

	      // Affichage de la pièce dans sa nouvelle position
				// Si c'est une promotion
	      if (type_deplacement == 8 || type_deplacement == 9)
					piece = dame;
	      // Affichage proprement dit de la pièce
	      affichage_piece (piece, couleur_piece,
					table_piece[echiquier[g_case_pour_etre_jouee.place].
					pos_table_piece].place);

	      // Affichage de la tour à sa nouvelle position si c'est un roque
	      if ((g_case_pour_etre_jouee.type == roi) && (coordonnee_echiquier -
															g_case_pour_etre_jouee.place == 2))	//Petit roque
				{
		  		if (couleur_piece == blanche)
		    	{
						g_case_pour_etre_jouee = table_piece[10];
						piece = tour;
						coordonnee_echiquier = 115;

						// Effacement de la tour
		      	affichage_piece (vide, couleur_piece, 117);
		    	}
		  		else
					{
						g_case_pour_etre_jouee = table_piece[26];
						piece = tour;
						coordonnee_echiquier = 31;
						// Effacement de la tour
						affichage_piece (vide, couleur_piece, 33);
					}

					// Affichage de la tour à sa nouvelle position
					affichage_piece (piece, couleur_piece, coordonnee_echiquier);
				}

	      if ((g_case_pour_etre_jouee.type == roi) && (coordonnee_echiquier -
														g_case_pour_etre_jouee.place == -2))	// Grand roque
				{
		  		if (couleur_piece == blanche)
					{
						g_case_pour_etre_jouee = table_piece[9];
						piece = tour;
						coordonnee_echiquier = 113;
	
						// Effacement de la tour
						affichage_piece (vide, echiquier[110].couleur_case, 110);
		    	}
		  		else
		    	{
						g_case_pour_etre_jouee = table_piece[25];
						piece = tour;
						coordonnee_echiquier = 29;
						// Effacement de la tour
						affichage_piece (vide, echiquier[26].couleur_case, 26);
		    	}

					// Affichage de la tour à sa nouvelle position
					affichage_piece (piece, couleur_piece, coordonnee_echiquier);
				}

	      // Effacement du pion pris si c'est une prise en passant
	      if (type_deplacement == 5)
				{
		  		if (g_case_pour_etre_jouee.couleur == blanche)
		    	{// Ceux sont les blancs qui jouent
						affichage_piece (vide, echiquier[coordonnee_echiquier +
							 										12].couleur_case, coordonnee_echiquier + 12);
		    	}
		  		else
					{// Ceux sont les noirs qui jouent
						affichage_piece (vide, echiquier[coordonnee_echiquier -
							 12].couleur_case, coordonnee_echiquier - 12);
					}
				}

	      couleur_case_rouge.red = 0;
	      couleur_case_rouge.green = 0;
	      couleur_case_rouge.blue = 0;

	      gdk_colormap_alloc_color (colormap, &couleur_case_rouge, FALSE,
					FALSE);
	      gdk_gc_set_foreground (Zone_dessin->style->
				     fg_gc[GTK_WIDGET_STATE (Zone_dessin)],
				     &couleur_case_rouge);

	      // Affichage du coup joué dans le cadre_partie et sauvegarde de la 
				// position.
	      sauvegarde_position (creation_affich_coups
				   (piece, humain_joue,
				    g_case_pour_etre_jouee.place,
				    coordonnee_echiquier, type_deplacement));

	      // Envoi à Gnuchess du coup joué.
	      if (gnuchess)
				{
					gtk_widget_set_sensitive (menu_jouer_gnuchess, FALSE);
					gtk_widget_set_sensitive (GTK_WIDGET(gtk_toolbar_get_nth_item(GTK_TOOLBAR (barre_outils), 6)), FALSE);
					g_io_add_watch ((GIOChannel *) channel_write, G_IO_OUT,
							(GIOFunc) writesocket,
							(gpointer) tab_sauve_partie[num_coup_joue].
							coup);
				}

	      // Incrémentation du nombre de coups joués
	      num_coup_joue++;

	      // MAJ des pieces prises
	      g_affichage_pieces_prises ();

	      // On autorise le retour en arrière
	      gtk_widget_set_sensitive (bouton_debut, TRUE);
	      gtk_widget_set_sensitive (bouton_recul, TRUE);

	      if (humain_joue == noire)
		humain_joue = blanc;
	      else
		humain_joue = noire;

	      affichage_joueur ();
	    }
	  g_case_pour_etre_jouee.type = vide;
	  g_jouer_coup ();
	}
      else
	{
	  // interdiction de sélectionner une pièce adverse
	  if (((echiquier[coordonnee_echiquier].couleur_piece == blanche)
	       && (humain_joue == blanc))
	      || ((echiquier[coordonnee_echiquier].couleur_piece == noire)
		  && (humain_joue == noir)))
	    g_case_pour_etre_jouee =
	      table_piece[echiquier[coordonnee_echiquier].pos_table_piece];
	}
    }

  couleur_case_rouge.red = 0;
  couleur_case_rouge.green = 0;
  couleur_case_rouge.blue = 0;

  gdk_colormap_alloc_color (colormap, &couleur_case_rouge, FALSE, FALSE);
  gdk_gc_set_foreground (Zone_dessin->style->
			 fg_gc[GTK_WIDGET_STATE (Zone_dessin)],
			 &couleur_case_rouge);

  return TRUE;
}

void annuler_dernier_coup ()
{
  GtkTreeIter iter, iterfils;
	gint x;
	GtkWidget *cadre_partie;
	cadre_partie=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "cadre_partie"));
	GtkListStore *coup_affiche;
	coup_affiche=(GtkListStore*)
								(gtk_data_list_get_by_name(widget_list, "coup affiche"));
	GtkWidget *Zone_dessin;
	Zone_dessin=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "Zone dessin"));
	GtkWidget *menu_enregistrer;
	menu_enregistrer=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "menu enregistrer"));
	GtkWidget *barre_outils;
	barre_outils=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "barre outils"));
	GIOChannel *channel_write;
	channel_write=(GIOChannel*)
								(gtk_data_list_get_by_name(widget_list, "channel write"));

  if (!gnuchess)
    {
      if (num_coup_joue > 1)
	{
	  num_coup_joue--;
	  num_coup_joue--;

	  for (x = 0; x < 33; x++)
	    table_piece[x] = tab_sauve_partie[num_coup_joue].table_piece[x];
	  for (x = 0; x < 144; x++)
	    echiquier[x] = tab_sauve_partie[num_coup_joue].echiquier[x];
	  if (humain_joue == blanc)
	    humain_joue = noir;
	  else
	    humain_joue = blanc;

	  // Suppression du dernier élément
	  gtk_tree_model_get_iter_first (GTK_TREE_MODEL (coup_affiche),
					 &iterfils);
	  iter = iterfils;
	  while (1)
	    {
	      if (gtk_tree_model_iter_next
		  (GTK_TREE_MODEL (coup_affiche), &iterfils))
		iter = iterfils;
	      else
		break;
	    }

	  if (humain_joue == blanc)
	    {
	      gtk_list_store_remove (coup_affiche, &iter);
	      if (gtk_tree_model_get_iter_first
		  (GTK_TREE_MODEL (coup_affiche), &iterfils))
		{
		  iter = iterfils;

		  while (1)
		    {
		      if (gtk_tree_model_iter_next
			  (GTK_TREE_MODEL (coup_affiche), &iterfils))
			iter = iterfils;
		      else
			break;
		    }
		  gtk_tree_selection_select_iter (gtk_tree_view_get_selection
						  (GTK_TREE_VIEW(cadre_partie)), &iter);
		}
	    }
	  else
	    gtk_list_store_set (coup_affiche, &iter, 2, "", -1);

	  g_position_courante_navigation--;

	  vider_liste (liste_coups_jouables);
	  liste_coups_jouables = NULL;
	  liste_coups_jouables = calcul_cases_jouables (liste_coups_jouables);
	  num_coup_joue++;

	  gtk_widget_set_sensitive (menu_enregistrer, TRUE);
		gtk_widget_set_sensitive (GTK_WIDGET(gtk_toolbar_get_nth_item
																		(GTK_TOOLBAR (barre_outils), 3)), TRUE);
	  partie_en_cours = TRUE;	// Indique que la partie est en cours de jeu.
	  partie_enregistree = FALSE;	// Indique que la partie n'est pas enregistrée

	  // Mise à jour de l'échiquier
	  gtk_widget_queue_draw (Zone_dessin);
	  g_affichage_pieces_prises ();

	  if (num_coup_joue < 2)
	    {
	      gtk_widget_set_sensitive (GTK_WIDGET(gtk_toolbar_get_nth_item
																			(GTK_TOOLBAR (barre_outils), 6)), FALSE);
	      g_initialisation_jeu ();
	    }
	}
    }
  else
    {
      if (num_coup_joue > 1)
	{
	  num_coup_joue--;
	  num_coup_joue--;
	  num_coup_joue--;

	  g_io_add_watch ((GIOChannel *) channel_write, G_IO_OUT, (GIOFunc) writesocket, (gpointer) "undo\nundo\n");

	  for (x = 0; x < 33; x++)
	    table_piece[x] = tab_sauve_partie[num_coup_joue].table_piece[x];
	  for (x = 0; x < 144; x++)
	    echiquier[x] = tab_sauve_partie[num_coup_joue].echiquier[x];
/*			if (humain_joue==blanc)
				humain_joue=noir;
			else
				humain_joue=blanc;
*/
	  // Suppression du dernier élément
	  gtk_tree_model_get_iter_first (GTK_TREE_MODEL (coup_affiche),
					 &iterfils);
	  iter = iterfils;
	  while (1)
	    {
	      if (gtk_tree_model_iter_next
		  (GTK_TREE_MODEL (coup_affiche), &iterfils))
		iter = iterfils;
	      else
		break;
	    }

	  if (humain_joue == blanc)
	    {
	      gtk_list_store_remove (coup_affiche, &iter);
	      if (gtk_tree_model_get_iter_first
		  (GTK_TREE_MODEL (coup_affiche), &iterfils))
		{
		  iter = iterfils;

		  while (1)
		    {
		      if (gtk_tree_model_iter_next
			  (GTK_TREE_MODEL (coup_affiche), &iterfils))
			iter = iterfils;
		      else
			break;
		    }
		  gtk_tree_selection_select_iter (gtk_tree_view_get_selection
						  (GTK_TREE_VIEW
						   (cadre_partie)), &iter);
		}
	    }
	  else
	    gtk_list_store_set (coup_affiche, &iter, 2, "", -1);

	  g_position_courante_navigation--;
	  g_position_courante_navigation--;

	  vider_liste (liste_coups_jouables);
	  liste_coups_jouables = NULL;
	  liste_coups_jouables = calcul_cases_jouables (liste_coups_jouables);
	  num_coup_joue++;

	  gtk_widget_set_sensitive (menu_enregistrer, TRUE);
		gtk_widget_set_sensitive (GTK_WIDGET(gtk_toolbar_get_nth_item
																		(GTK_TOOLBAR (barre_outils), 3)), TRUE);
	  partie_en_cours = TRUE;	// Indique que la partie est en cours de jeu.
	  partie_enregistree = FALSE;	// Indique que la partie n'est pas enregistrée

	  // Mise à jour de l'échiquier
	  gtk_widget_queue_draw (Zone_dessin);
	  g_affichage_pieces_prises ();

	  if (num_coup_joue < 2)
	    {
	      gtk_widget_set_sensitive (GTK_WIDGET(gtk_toolbar_get_nth_item
																			(GTK_TOOLBAR (barre_outils), 6)), FALSE);
	      g_initialisation_jeu ();
	      gnuchess = TRUE;
	    }
	}
    }
}

gboolean g_afficher_coups_jouables (type_piece case_selectionnee)
{
  register int x, y, z;
  int couleur_piece = blanche;
  char piece;
  int position_table_piece = 0;
  GList *liste = NULL;
  GdkColor couleur_case_rouge;
  GdkColormap *colormap;
  int coordonnee_echiquier;
	GtkWidget *Zone_dessin;
	Zone_dessin=(GtkWidget*)
								(gtk_data_list_get_by_name(widget_list, "Zone dessin"));
	GtkToolItem *item_coup_jouable;
	item_coup_jouable=(GtkToolItem*)
								(gtk_data_list_get_by_name(widget_list, "item coup jouable"));

  // effacement des anciens coups jouables
  if (!gtk_toggle_tool_button_get_active
      (GTK_TOGGLE_TOOL_BUTTON (item_coup_jouable)))
	{
		// On cherche la position de la pièce séléctionnée dans table_piece[]
		for (x = 1; x < 33; x++)
		{
			if (table_piece[x].type != vide)
			{
				if (table_piece[x].place == case_selectionnee.place)
				{
					position_table_piece = x;
					x = 33;	// Pour sortir de la boucle une fois trouvé
				}
			}
		}

		// Une pièce est sélectionnée alors peut être des carrés rouges sont
		// affichés.
		if (position_table_piece != 0)	
		{
			// On prend chaque coup jouable de la pièce et on efface le carré rouge
			liste = g_list_first (liste_coups_jouables);
			y = g_list_length (liste);
			if (y > 0)
			{
				for (x = 0; x < y; x++)
				{
					if (((struct struct_coups_jouables *)(liste->data))->pos_piece_tab 
								== position_table_piece
							&& ((struct struct_coups_jouables *) (liste->data))->coup_ami
								== FALSE)
					{
						couleur_piece = echiquier[((struct struct_coups_jouables *)
							(liste->data))->coup].couleur_piece;
						piece = echiquier[((struct struct_coups_jouables *)
							(liste->data))->coup].type_piece;
						if (piece != vide)	// Si le coup jouable est sur une case occupée
						{
							// Effacement de la case
							affichage_piece (vide,echiquier[((struct struct_coups_jouables*)
											(liste->data))->coup].couleur_case,
											((struct struct_coups_jouables *) (liste->data))->coup);
							// affichage de la piece
							affichage_piece (piece, couleur_piece,
									 ((struct struct_coups_jouables *) (liste->data))->coup);
						}
						else
						{
							// Affichage d'une case vide
							affichage_piece (vide,echiquier[((struct struct_coups_jouables*)
											(liste->data))->coup].couleur_case,
											((struct struct_coups_jouables *) (liste->data))->coup);
						}
					}
					liste = g_list_next (liste);
				}
			}
		}

		// Changement d'état du bouton "coup jouable" dans la barre_outils
		gtk_toggle_tool_button_set_active (GTK_TOGGLE_TOOL_BUTTON
				 																						(item_coup_jouable), FALSE);
	}
  else
  {
		// Changement d'état du bouton "coup jouable" dans la barre_outils
		if (gtk_toggle_tool_button_get_active
				(GTK_TOGGLE_TOOL_BUTTON (item_coup_jouable)))
			gtk_toggle_tool_button_set_active (GTK_TOGGLE_TOOL_BUTTON
																										(item_coup_jouable), TRUE);

		couleur_case_rouge.red = 65000;
		couleur_case_rouge.green = 0;
		couleur_case_rouge.blue = 0;

		colormap = gdk_drawable_get_colormap (Zone_dessin->window);
		gdk_colormap_alloc_color (colormap, &couleur_case_rouge, FALSE, FALSE);
		gdk_gc_set_foreground (Zone_dessin->style->
				 fg_gc[GTK_WIDGET_STATE (Zone_dessin)], &couleur_case_rouge);

		// si la souris est bien sur une des cases de l'échiquier et non sur un bord
		if ((souris.x != 0) && (souris.y != 0))
		{
			// conversion des coordonnées x y en coordonnées tableau
			coordonnee_echiquier = 110 + ((souris.x - 1) - (12 * (souris.y - 1)));

			// effacement des anciens coups jouables
			if (case_selectionnee.type != vide)
			{
				// Effacement des anciens petits carrés rouges
				liste = g_list_first (liste_coups_jouables);
				y = g_list_length (liste);
				for (x = 1; x < 33; x++)
				{
					if (table_piece[x].type != vide)
					{
						if (table_piece[x].place == case_selectionnee.place)
							position_table_piece = x;
					}
				}
				if (y > 0)
				{
					for (x = 0; x < y; x++)
					{
						if ((((struct struct_coups_jouables *) (liste->data))->
								pos_piece_tab == position_table_piece)
							&& (((struct struct_coups_jouables *) (liste->data))->coup_ami ==
								FALSE))
						{
							couleur_piece = echiquier[((struct struct_coups_jouables *)
															(liste->data))->coup].couleur_piece;
							piece = echiquier[((struct struct_coups_jouables *)
															(liste->data))->coup].type_piece;
							// affichage de la piece ou de la case considérée
							if (piece != vide)	// Si le coup jouable est sur une case occupée
							{
								// Effacement de la case
								affichage_piece (vide, echiquier[((struct struct_coups_jouables*)
																(liste->data))->coup].couleur_case,
													((struct struct_coups_jouables *) (liste->data))->coup);
								// affichage de la piece
								affichage_piece (piece, couleur_piece,
													((struct struct_coups_jouables *) (liste->data))->coup);
							}
							else
							{
								// Affichage d'une case vide
								affichage_piece (vide, echiquier[((struct struct_coups_jouables*)
									(liste->data))->coup].couleur_case,
													((struct struct_coups_jouables *) (liste->data))->coup);
							}
						}
						liste = g_list_next (liste);
					}
				}
			}

			// Affichage des coups jouables de la nouvelle pièce pointée
			for (z = 1; z < 33; z++)
			{
				// interdiction de sélectionner une pièce adverse
				if (((z < 17) && (humain_joue == blanc)) ||
						((z > 16) && (humain_joue == noir)))
				{
					if ((table_piece[z].place == coordonnee_echiquier)
							&& (table_piece[z].type != vide))
					{
						liste = g_list_first (liste_coups_jouables);
						y = g_list_length (liste);
						if (y > 0)
						{
							for (x = 0; x < y; x++)
							{
								if ((((struct struct_coups_jouables *) (liste->data))->
											pos_piece_tab == z)
										&& (((struct struct_coups_jouables *) (liste->data))->
											coup_ami == FALSE))
								{
									if (!g_echiquier_inverse)
										gdk_draw_rectangle (Zone_dessin->window,
											Zone_dessin->style->fg_gc[GTK_WIDGET_STATE(Zone_dessin)],
											TRUE,
											20 + ((echiquier[((struct struct_coups_jouables *)
											(liste->data))->coup].x - 1) * TAILLE_PIECE)
											+(TAILLE_PIECE/4),
											20 + ((8 - echiquier[((struct struct_coups_jouables *)
											(liste->data))->coup].y) * TAILLE_PIECE)+(TAILLE_PIECE/4),
											TAILLE_PIECE-(gint)(TAILLE_PIECE/2),
											TAILLE_PIECE-(gint)(TAILLE_PIECE/2));
									else
										gdk_draw_rectangle (Zone_dessin->window,
											Zone_dessin->style->fg_gc[GTK_WIDGET_STATE(Zone_dessin)],
											TRUE,
											((TAILLE_PIECE*8)+20) - ((echiquier
											[((struct struct_coups_jouables *) (liste->data))->coup].x
											* TAILLE_PIECE))+(gint)(TAILLE_PIECE/4),
											((TAILLE_PIECE*7)+20) - ((8 - echiquier
											[((struct struct_coups_jouables *)(liste->data))->coup].y)
											* TAILLE_PIECE)+(gint)(TAILLE_PIECE/4),
											TAILLE_PIECE-(gint)(TAILLE_PIECE/2),
											TAILLE_PIECE-(gint)(TAILLE_PIECE/2));
								}
								liste = g_list_next (liste);
							}
						}
					}
				}
			}
		}
      couleur_case_rouge.red = 0;
      couleur_case_rouge.green = 0;
      couleur_case_rouge.blue = 0;

      gdk_colormap_alloc_color (colormap, &couleur_case_rouge, FALSE, FALSE);
      gdk_gc_set_foreground (Zone_dessin->style->
			     fg_gc[GTK_WIDGET_STATE (Zone_dessin)],
			     &couleur_case_rouge);
    }

  return TRUE;
}
